package tests;

import utest.*;
import http.Message;

public class MessageTest extends Testable {
    class Foo extends Message {}

    public void assertion() {
        Message msg = new Foo();
        msg.addHeader("something","some value");
        check("The class is not declared as abstract.",
          isAbstractClass(className()));
        check("The getHeader() method returns something for a non-existing field.",
          msg.getHeader("else") == null);
        check("The getHeader() method does not return a value for an existing field.",
          msg.getHeader("something") != null);
    }

    public int score() { return 3; }
    public String description() { return "http.Message"; }

    public String className() { return "http.Message"; }
    public Object[] expectedMethods() throws Exception {
        return new Object[]
        { constructor(className())
        , method(className() + ".addHeader", String.class, String.class)
        , method(className() + ".getHeader", String.class)
        };
    }

    public static void main(String... args) {
        Test.main(new MessageTest());
    }
}
