package tests;

import utest.*;
import http.Status;
import http.Response;
import http.NotFoundResponse;

public class NotFoundResponseTest extends Testable {
    public void assertion() {
        NotFoundResponse r = new NotFoundResponse();

        check("Fields are not properly set.",
          r.status == Status.NOT_FOUND &&
          r.getHeader("Connection").equals("close") &&
          r.getHeader("Content-length").equals("33") &&
          r.getHeader("Content-type").equals("text/plain") &&
          r.body.equals("The requested page was not found."));
    }

    public int score() { return 2; }
    public String description() { return "http.NotFoundResponse"; }

    public String className() { return "http.NotFoundResponse"; }
    public Object[] expectedMethods() throws Exception {
        return new Object[]
        { constructor(className())
        , method("http.Response.toString")
        , method("http.Message.addHeader", String.class, String.class)
        , method("http.Message.getHeader", String.class)
        };
    }

    public Object[] expectedFields() throws Exception {
        return new Object[]
        { field("http.Response.status")
        , field("http.Response.body")
        };
    }

    public static void main(String... args) {
        Test.main(new NotFoundResponseTest());
    }
}
