package tests;

import utest.*;
import http.Status;

public class StatusTest extends Testable {
    public void assertion() {
        Status st;

        st = Status.OK;
        check("Invalid definition: Status.OK",
          st.code == 200 && st.reason.equals("OK"));
        st = Status.BAD_REQUEST;
        check("Invalid definition: Status.BAD_REQUEST",
          st.code == 400 && st.reason.equals("Bad Request"));
        st = Status.NOT_FOUND;
        check("Invalid definition: Status.NOT_FOUND",
          st.code == 404 && st.reason.equals("Not Found"));
        st = Status.ERROR;
        check("Invalid definition: Status.ERROR",
          st.code == 500 && st.reason.equals("Internal Server Error"));
        st = Status.NOT_IMPLEMENTED;
        check("Invalid definition: Status.NOT_IMPLEMENTED",
          st.code == 501 && st.reason.equals("Not Implemented"));
    }

    public int score() { return 2; }
    public String description() { return "http.Status"; }

    public String className() { return "http.Status"; }

    public Object[] expectedMethods() throws Exception {
        return new Object[]
        { staticMethod(className() + ".values")
        , staticMethod(className() + ".valueOf", String.class)
        , staticMethod("java.lang.Enum.valueOf", Class.class, String.class)
        , method("java.lang.Enum.name")
        , method("java.lang.Enum.equals", Object.class)
        , method("java.lang.Enum.hashCode")
        , method("java.lang.Enum.toString")
        , method("java.lang.Enum.ordinal")
        , method("java.lang.Enum.getDeclaringClass")
        , method("java.lang.Enum.compareTo", Object.class)
        , method("java.lang.Enum.compareTo", Enum.class)
        };
    }

    public Object[] expectedFields() throws Exception {
        return new Object[]
        { staticField(className() + ".OK")
        , staticField(className() + ".BAD_REQUEST")
        , staticField(className() + ".NOT_FOUND")
        , staticField(className() + ".ERROR")
        , staticField(className() + ".NOT_IMPLEMENTED")
        , field(className() + ".reason")
        , field(className() + ".code")
        };
    }

    public static void main(String... args) {
        Test.main(new StatusTest());
    }
}
